Subject: Re: GCC 3.0 for i686-pc-cygwin target, bootstrap fails
From: "Corwin Joy" <[email-masked]>
To: "Di-an Jan" <[email-masked]>, <[email-masked]>, <[email-masked]>
Cc: <[email-masked]>
Date: Tue, 31 Jul 2001 01:27:20 -0500

----- Original Message -----
From: "Di-an Jan" <[email-masked]>
To: <[email-masked]>; <[email-masked]>
Cc: <[email-masked]>; <[email-masked]>
Sent: Monday, July 30, 2001 11:54 PM
Subject: Re: GCC 3.0 for i686-pc-cygwin target, bootstrap fails

> > ../../gcc-3.0/gcc/config/i386/i386.md:289: unknown rtx
> > code 'define_asm_attributes
>
<...snip..>
> > Anyway, the problem seems to have something to do with carriage return
> > versus line-feed under Cygwin.
<...snip..>
> I ran into the same. The problem is that '\r' is not recognized as white
> space in various parts of "rtl.c". Specifically, "read_name" thinks '\r'
> is a part of the name.
>
> A better fix is probably to put the sources under a directory mounted
> textmode (or change the mount to binmode if the files are already
> extracted). If the directory is set for binmode, Cygwin's "tar" does not
> add extra '\r' but external programs such as WinZip might, and "rtl.c"
> don't handle it well enough.

This would likely be what bit me.  As someone more conversant with NT than
Cygwin I just used WinZip to uncompress the distribution file which may have
added the extra '\r'.

>
> I think a note should be added to the "Host/target specific installation
> notes" page that either the sources should be extracted with Cygwin "tar"
> or extracted to a directory mounted textmode.
>
> A strong warning should also be added to the Cygwin User's Guide that
> binmode cannot maintain Unix newline conventions if non-Cygwin programs
> such as WinZip are used, and some programs will fail.
>
> "rtl.c" shows a mixture of handling and ignoring '\r'. I could probably
> fix "rtl.c" but it's probably not worthwhile. Many other files probably
> have this problem too. Perhaps a note about newline/whitespace handling
> can be added to one of the coding standards so that in the future things
> might be more consistent.

You may be right, however, I can say that for Cygwin  after fixing i386.md
the remainder of the make bootstrap process went through and the resulting
c++ compiler seems to be working fine on some relatively complex programs.
So, it may actually be a somewhat localized problem.

Corwin

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Bug reporting:         http://cygwin.com/bugs.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/